<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE sect1 PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
   "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
  <!ENTITY % general-entities SYSTEM "../general.ent">
  %general-entities;

   <!ENTITY extra-cmake-modules-download-http "&kf6-download-http;/extra-cmake-modules-&kf6-version;.tar.xz">
   <!ENTITY extra-cmake-modules-download-ftp  " ">
   <!ENTITY extra-cmake-modules-md5sum        "22bce8bd85c1ead07bda8a00518d1120">
   <!ENTITY extra-cmake-modules-size          "320 KB">
   <!ENTITY extra-cmake-modules-buildsize     "9.5 MB">
   <!ENTITY extra-cmake-modules-time          "less than 0.1 SBU">
]>

<sect1 id="extra-cmake-modules" xreflabel="extra-cmake-modules-&kf6-version;">
  <?dbhtml filename="extra-cmake-modules.html"?>


  <title>extra-cmake-modules-&kf6-version;</title>

  <indexterm zone="extra-cmake-modules">
    <primary sortas="a-extra-cmake-modules">extra-cmake-modules</primary>
  </indexterm>

  <sect2 role="package">
    <title>Introduction to Extra Cmake Modules</title>

    <para>
      The <application>Extra Cmake Modules</application> package contains
      extra <application>CMake</application> modules used by
      <application>KDE Frameworks</application> and other packages.
    </para>

    &lfs122_checked;

    <bridgehead renderas="sect3">Package Information</bridgehead>
    <itemizedlist spacing="compact">
      <listitem>
        <para>
          Download (HTTP): <ulink url="&extra-cmake-modules-download-http;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download (FTP): <ulink url="&extra-cmake-modules-download-ftp;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download MD5 sum: &extra-cmake-modules-md5sum;
        </para>
      </listitem>
      <listitem>
        <para>
          Download size: &extra-cmake-modules-size;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated disk space required: &extra-cmake-modules-buildsize;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated build time: &extra-cmake-modules-time;
        </para>
      </listitem>
    </itemizedlist>

    <bridgehead renderas="sect3">Extra Cmake Modules Dependencies</bridgehead>

    <bridgehead renderas="sect4">Required</bridgehead>
    <para role="required">
      <xref linkend="cmake"/>
    </para>

    <bridgehead renderas="sect4">Recommended</bridgehead>
    <para role="recommended">
      <xref linkend="qt6"/>
    </para>

    <bridgehead renderas="sect4">Optional</bridgehead>
    <para role="optional">
      <xref linkend="sphinx"/> (for building documentation),
      <ulink url="https://pypi.org/project/PyQt5/">PyQt</ulink> (experimental
      support for building KDE Python bindings), and
      <ulink url="https://github.com/fsfe/reuse-tool/">ReuseTool</ulink> (for running 
      internal tests)
    </para>

  </sect2>

  <sect2 role="installation">
    <title>Installation of Extra Cmake Modules</title>

    <para>
      Install <application>Extra Cmake Modules</application> by running the
      following commands:
    </para>

<screen><userinput>sed -i '/"lib64"/s/64//' kde-modules/KDEInstallDirsCommon.cmake &amp;&amp;

sed -e '/PACKAGE_INIT/i set(SAVE_PACKAGE_PREFIX_DIR "${PACKAGE_PREFIX_DIR}")' \
    -e '/^include/a set(PACKAGE_PREFIX_DIR "${SAVE_PACKAGE_PREFIX_DIR}")' \
    -i ECMConfig.cmake.in &amp;&amp;

mkdir build &amp;&amp;
cd    build &amp;&amp;

cmake -D CMAKE_INSTALL_PREFIX=/usr -D BUILD_WITH_QT6=ON .. &amp;&amp;
make</userinput></screen>

    <para>
      This package does not come with a test suite.
    </para>

    <note><para>
      Unlike other KF6 packages, this module is installed in /usr because
      it can be used by some non-KF6 packages.
    </para></note>

    <para>
      Now, as the <systemitem class="username">root</systemitem> user:
    </para>

<screen role="root"><userinput>make install</userinput></screen>

  </sect2>

  <sect2 role="commands">
    <title>Command Explanations</title>

    <para>
      <command>sed ... Modules/KDEInstallDirs.cmake</command>:
      This command disables applications using cmake from attempting to
      install files in a <filename class="directory">lib64</filename>
      sub-directory.
    </para>

    <para>
    <command>sed ... ECMConfig.cmake.in</command>:
      This command protects the global <application>cmake</application>
      variable <envar>PACKAGE_PREFIX_DIR</envar> from being changed when
      checking ECM presence: since we install ECM into <filename
      class="directory">/usr</filename>, the check would set that variable to
      <filename class="directory">/usr</filename>, while most KDE packages
      expect it to be set to <filename class="directory">/opt/kf6</filename>
      and would fail to build if it is set to something else.
    </para>
  </sect2>

  <sect2 role="content">
    <title>Contents</title>

    <segmentedlist>
      <segtitle>Installed Programs</segtitle>
      <segtitle>Installed Libraries</segtitle>
      <segtitle>Installed Directories</segtitle>

      <seglistitem>
        <seg>
          None
        </seg>
        <seg>
          None
        </seg>
        <seg>
          /usr/share/ECM and
          /usr/share/doc/ECM (if documentation was built)
        </seg>
      </seglistitem>
    </segmentedlist>

  </sect2>

</sect1>
